/*     */

#include "common_defs.h"

/******************************************
 *  ADC    ADC  *
 ******************************************/
void ADCInit(void)
{
   ADC_PORT_DIR  = 0x5F;           //   - ,  2- .    
   ADC_PORT      = 0x00;           //      
   ADMUX   = 0;
   ADCSRA &= ~_BV(ADEN);                          //   ADC
   ADCSRA |= _BV(ADEN) | _BV(ADPS2) | _BV(ADPS0); //   ADC,  ,   ADC = MCU Clock/32
   ADMUX |= _BV(REFS0);                           //    AVCC
   ADCwork();
   Wait_ms(500);                 //      260 , 500  -    :)
}

/******************************************
 *  ADC  *
 ******************************************/
void ADCwork(void)
{
   Wait_us(270);                        //      260 
   ADCSRA |= _BV(ADSC);                 //   
   while(bit_is_set(ADCSRA, ADSC)) {}   // ,    
}

/******************************************
 *   ADC                 *
 ******************************************/
UINT16 GetADC (UINT8 channel)
{
   UINT8         tmpL;
   UINT8         tmpH;

   ADMUX &= ~0x07;
   ADMUX |= (channel & 0x07); //   ADC
   ADCwork();
   tmpL = ADCL;
   tmpH = ADCH;
   
   return((tmpH << 8) + tmpL);
}

/******************************************************************
 *               ADC                           *
 ******************************************************************/
UINT16 GetVolt(char * volt)
{
   UINT16 vcc;

   vcc = (UINT16)((float)GetADC(7)*(float)ADC_VCC_CONV_CONST);

   buff_print_dec(&volt, ((vcc+5.0)/10.0));

   *(volt++) = 'V';

   *(volt++) = '\0';

   return vcc;
}
