/*     Sanyo LC72131 */

#include "common_defs.h"

/**************************************************************************
 *   32-      LC72131 *
 **************************************************************************/
void send_word(UINT32 word)
{
   UINT32 mask = 0x00000001; //  LSB 
   UINT8  i;

   for (i = 0; i < 32; i++)
   {
      if (mask & word)
      {
         SetDIHigh();
      }
      else
      {
         SetDILow();
      }
      mask <<= 1;

      if (8 == i)
      {
         SetCEHigh();      //     / LC72132
      }

      SetCLHigh();         // 
      SetCLLow();          // *
   }

   SetCELow();             //     / LC72131
   SetDILow();
}

/*     */
void InitSynthPins(void)
{
   SYNTH_PORT     |= _BV(SYNTH_PIN_CL) | _BV(SYNTH_PIN_DI) | _BV(SYNTH_PIN_CE); //  
   SYNTH_PORT_DIR |= _BV(SYNTH_PIN_CL) | _BV(SYNTH_PIN_DI) | _BV(SYNTH_PIN_CE); //   
   SetCELow();
   SetCLLow();
   SetDILow();
}

/* CL (Clock) */
void SetCLHigh(void)
{
   SYNTH_PORT |= _BV(SYNTH_PIN_CL);
   Wait_us(2);
}

void SetCLLow(void)
{
   SYNTH_PORT &= ~_BV(SYNTH_PIN_CL);
   Wait_us(2);
}

/* DI (Data Input to LC72131) */
void SetDIHigh(void)
{
   SYNTH_PORT |= _BV(SYNTH_PIN_DI);
   Wait_us(2);
}

void SetDILow(void)
{
   SYNTH_PORT &= ~_BV(SYNTH_PIN_DI);
   Wait_us(2);
}

/* CE (Chip Enable) */
void SetCEHigh(void)
{
   SYNTH_PORT |= _BV(SYNTH_PIN_CE);
   Wait_us(2);
}

void SetCELow(void)
{
   SYNTH_PORT &= ~_BV(SYNTH_PIN_CE);
   Wait_us(2);
}
