#define DOT_LENTH_IN_TIMER_TICKS 51500 //     (   ""   )
#define FREQUENCY      144400          //  , 
#define FREQ_STEP      0               //   ,    (.  )

// 0 -  200    
// 1 -  100    
// 2 -   50    
// 3 -   25    
// 4 -   12.5  
// 5 -    6.25 
// 6 -   20    
// 7 -   10    
// 8 -    2     -     144  -  16-  :(
// 9 -    6     -    ,  ...?

//#define BASE_TIME_OFF   4      //     ( )
#define BASE_TIME_OFF    18      //      ".." (  , 18  1 )

//   2
// IFS = 1 -  
// DOC0 = 1 -      DO  
//                               DDD
//                      I    DDUUOOO
//                      F    ZZLLCCC
//                      S    0110210
#define CTRL_WORD2 0b00010000001100100000000000000000
//                   |                              |
//                   31                             0


#define IN1  0b00101000 //   1 ( CTRL_WORD1)
#define IN2  0b00101001 //   2 ( CTRL_WORD2)

#include "common_defs.h"
#include "Morse.h"

/***************************************************************************
 *                                                     *
 ***************************************************************************/
//   1
//        XS (XS=0 - 4.5 )
// DVS (  2) - 
FREQ_CONST freq_const_array[] =
{
   //         RRRR
   //         3210
   {200,    0b00000010}, //   100     ,  200    
   {100,    0b00010010}, //    50     ,  100    
   { 50,    0b00110010}, //    25     ,   50    
   { 25,    0b01000010}, //    12.5   ,   25    
   { 12.5,  0b01010010}, //     6.25  ,   12.5  
   {  6.25, 0b01110010}, //     3.125 ,    6.25 
   { 20,    0b10000010}, //    10     ,   20    
   { 10,    0b10100010}, //     5     ,   10    
   {  2,    0b10110010}, //     1     ,    2     -     144  :(
   {  6,    0b11000010}, //     3     ,    6     -    ,  ...?
};

//   ( )       
//         BASE_TIME_OFF
const UINT16 beaconTimeOff[] =
{65535,65535,65535,65535,65535,65535,65535,65535,65535,65535,400, 60, 20, 10, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}; //    
//   0     1     2     3     4     5     6     7     8     9  10  11  12  13  14 15 16 17 18 19 20 21 22 23 24 -    

UINT32 volatile InterruptsCounter = 0;
UINT32 devider;
UINT32 freq_step_code;
extern UINT8 scratchpad[9];
extern UINT8 p_rom[8];

/***************************************************************************
 *                                                 *
 ***************************************************************************/
//const char message[] = "VVV de UA0LTB PN53XC\0";
const char message[] = "VVV de RZ0LWA PN54UU\0";
//const char message[] = "B\0";

/***************************************************************************
 *                                          *
 ***************************************************************************/
void Power_ON(void)
{
   CTRL_PORT |=  _BV(CTRL_PIN_POWER_ON);   //  
}

/****************************************************************************
 *                                          *
 ****************************************************************************/
void Power_OFF(void)
{
   CTRL_PORT &= ~_BV(CTRL_PIN_POWER_ON);   //  
}

/***************************************************************************
 *                                                           *
 ***************************************************************************/
void PTT_ON(void)
{
   CTRL_PORT |=  _BV(CTRL_PIN_PTT);        //  
}

/****************************************************************************
 *                                                            *
 ****************************************************************************/
void PTT_OFF(void)
{
   CTRL_PORT &= ~_BV(CTRL_PIN_PTT);        //  
}

/****************************************************************************
 *   /                                 *
 ****************************************************************************/
void IOinit(void)
{
   wdt_disable();                     //  WDT
   StopTCNT1();

   CTRL_PORT      = 0x00;             //   
   CTRL_PORT_DIR  = 0xFF;             //   

   LCD_PORT      = 0x00;              //   
   LCD_PORT_DIR  = 0xFF;              //   

   CTRL_PORT2      = 0x00;            //   
   CTRL_PORT2_DIR  = 0xFF;            //   

   ACSR    |= _BV(ACD);               //     
   MCUCSR  |= _BV(JTD);               //  JTAG (         )

   TIMSK     |= _BV(TOIE1);           //    - 1

   CTRL_PORT_DIR  |= _BV(CTRL_PIN_PTT) | _BV(SYNTH_PIN_DI) | _BV(CTRL_PIN_POWER_ON);   //   

   CTRL_PORT_DIR  &= ~_BV(CTRL_PIN_LOCK);  //   
   CTRL_PORT      |=  _BV(CTRL_PIN_LOCK);  //  

   CTRL_PORT2_DIR &= ~_BV(CTRL_PIN_MODE);  //   
   CTRL_PORT2     |=  _BV(CTRL_PIN_MODE);  //  

   MCUCR  |= _BV(ISC11);     //       INT1 (pin 17)
   MCUCR  &= ~_BV(ISC10);    // *
   GICR   |= _BV(INT1);      //    INT1

   Power_OFF();              //     

   PTT_OFF();                //  

   InitSynthPins();

   LCDPortInit();

   ADCInit();

   OWIinit();

   Wait_ms(50);

   GIFR |= _BV(INTF1);       //     -    INT1,   
}

/****************************************************************************
 *     - 1                 *
 ****************************************************************************/
ISR(TIMER1_OVF_vect)
{
   InterruptsCounter++;
}

/****************************************************************************
 *      TCNT1                                     *
 ****************************************************************************/
void Wait(UINT32 delay)
{
   InterruptsCounter = 0;

   for (;;)
   {
      sleep_mode();
      _WDR();

      cli();
      TCNT1 = DOT_LENTH_IN_TIMER_TICKS;
      sei();

      if (InterruptsCounter >= delay)
      {
         break;
      }
   }
}

/****************************************************************************
 *    INT1 -                *
 *      LCD    ""           *
 ****************************************************************************/
ISR(INT1_vect)
{
   TestMode();
}

/*************************************************
 *       LCD    *
 *************************************************/
void TestMode(void)
{
   char          temperature[6];
   bool          result_temp;
   char          volt[6];
   UINT16        result_volt;
   float         u_ant;
   UINT8         counter = 0;
   UINT8         i;

   cli();
   wdt_disable();
   StopTCNT1();

   GICR &= ~_BV(INT1);          //    INT1
   GIFR |= _BV(INTF1);          //     -    INT1,   

   LCD_PORT      = 0x00;        //   
   LCD_PORT_DIR  = 0xFF;        //   

   LCDinit();                   //  LCD

   devider   = ((UINT32)(FREQUENCY/freq_const_array[FREQ_STEP].freq_step) << 8); // 
   freq_step_code = ((UINT32)freq_const_array[FREQ_STEP].freq_value) << 24;      //   

   Power_ON();                  //  

   Wait_ms(100);

   ProgramSynth();              //  

   Wait_ms(100);

   PTT_ON();                    //  

   ADCSRA |= _BV(ADEN) | _BV(ADPS2) | _BV(ADPS0); //   ADC,  ,   ADC = MCU Clock/32
   result_temp = GetTemp(&temperature[0]);        //  

   DDRx_OWI_PORT  |=  _BV(OWI_LINE);              //  1-Wire  
   PORTx_OWI_PORT |= _BV(OWI_LINE);               //   1-Wire  1

   Wait_ms(100);

   sei();

   while(1)      // ,     "" :)
   {
      result_temp = GetTemp(&temperature[0]); //  

      result_volt = GetVolt(&volt[0]); //     (ADC7)

      u_ant = (((float)GetADC(5)*(float)ADC_OUTPUT_POWER_CONST)+5.0)/10; //     (ADC5)

      //      LCD
      Locate (1, 0);
      lcd_print_dec_float("", result_volt, 1); //    
      lcd_print_dec_float("v ", (UINT16)((u_ant*u_ant)/10.0), 1);                           //    
      lcd_print_str("w    ");                  //     

      Locate (2, 0);
      //    (2 ,  . )
      if(result_volt)
      {
         lcd_print_str(&volt[0]);
         lcd_print_char(' ');
      }

      // 
      if(result_temp)
      {
         lcd_print_str(&temperature[0]);
         lcd_print_char(' ');
      }

      // Lock/Unlock
      if (CTRL_PORT_PIN & _BV(CTRL_PIN_LOCK)) lcd_print_char('L');
      else lcd_print_char('U');

      //      
      lcd_print_dec_float(" P", (UINT16)(float)beaconTimeOff[(UINT16)(((float)result_volt+5.0)/10.0)], -1);
      lcd_print_str("       "); //     

      // ,   ?
      if (CTRL_PORT2_PIN & _BV(CTRL_PIN_MODE)) //  ?
      {
         counter = 0;
         for (i=0; i<5; i++)
         {
            Wait_ms(50);
            if (CTRL_PORT2_PIN & _BV(CTRL_PIN_MODE)) //  ?
            {
               counter++;
            }
         }
         if (counter >= 5) break;
      }
   }

   GIFR |= _BV(INTF1);    //     -    INT1,   

   wdt_enable(WDTO_30MS); //  
   while(1) {};           // *
}

/****************************************************************************
 *                                M A I N                                   *
 ****************************************************************************/
int main(void)
{
   UINT8         symbol_code;
   UINT8         symbol_length;
   UINT16        letter;
   UINT16        current_delay;
   UINT8         letter_index;
   UINT8         result_volt;

   float         voltage;

   char          temperature[6];
   bool          result_temp;
   char          volt[6];

   char          *p_str, *curr_str;

   cli();    //  .       .
             //  -   !
   IOinit();

   LCDinit();                                //  LCD

   if (~CTRL_PORT2_PIN & _BV(CTRL_PIN_MODE)) //  ""  ?
   {
      TestMode(); //   -    
   }

   p_str     = (char*) malloc (sizeof(message)+12); // 12 -     " 14V M10C"  

   devider   = ((UINT32)(FREQUENCY/freq_const_array[FREQ_STEP].freq_step) << 8); // 
   freq_step_code = ((UINT32)freq_const_array[FREQ_STEP].freq_value) << 24;    //   

   StartTCNT1();
   sei();
   wdt_enable(WDTO_2S);
   Wait(MORSE_DOT_LENGTH);     //     

   for (;;)
   {
      curr_str    = p_str;
      memset (p_str, sizeof(message)+12, 0);  //   (  )
      curr_str = strcpy (p_str, message) + strlen(message);

      Power_ON();                //  

      Wait(MORSE_DOT_LENGTH);    //     

      cli();
      ADCSRA |= _BV(ADEN) | _BV(ADPS2) | _BV(ADPS0); //   ADC,  ,   ADC = MCU Clock/32
      PORTx_OWI_PORT |= _BV(OWI_LINE);               //  QWI   1
      sei();

      Wait(MORSE_DOT_LENGTH);   //     

      result_temp = GetTemp(&temperature[0]); //  

      ProgramSynth();              //  

      Wait(MORSE_DASH_LENGTH*2);   //   2     

      result_volt = GetVolt(&volt[0]); //    
      if (result_volt)
      {
         curr_str = strcpy(curr_str, " ") + strlen(" ");
         curr_str = strcpy(curr_str, &volt[0]) +  + strlen(&volt[0]);
      }

      if (result_temp)
      {
         curr_str = strcpy(curr_str, " ") + strlen(" ");
         strcpy(curr_str, &temperature[0]);
      }

      cli();
      ADCSRA &= ~_BV(ADEN);              //   ADC
      PORTx_OWI_PORT &= ~_BV(OWI_LINE);  //  QWI   0
      sei();

      letter_index = 0;
      for(;;)
      {
         letter = p_str[letter_index++];

         if (SPACE != letter)
         {
            letter        = (letter - EXCLAMATION_MARK)<<1;
            symbol_code   = __LPM((UINT16)(&morse_lookup_table[0]+letter++));   //p_morse_lookup_table[letter].symbol_code;
            symbol_length = __LPM((UINT16)(&morse_lookup_table[0]+letter));     //p_morse_lookup_table[letter].symbol_length;

            //   
            for (; symbol_length > 0; --symbol_length)
            {
               PTT_ON();
               if (symbol_code & 0x80)        //      
                  current_delay = MORSE_DOT_LENGTH;
               else
                  current_delay = MORSE_DASH_LENGTH;

               symbol_code <<= 1;

               Wait(current_delay);           //     
               PTT_OFF();

               if ((!p_str[letter_index]) && (1 == symbol_length)) break; //       

               Wait(MORSE_PAUSE_WITHIN_SIGN); //    
            }

            if (!p_str[letter_index]) break;  //       

            Wait(MORSE_PAUSE_BETWEEN_SIGNES); //   

         }
         else
         {
            Wait(MORSE_PAUSE_BETWEEN_WORDS);  //     
         }
      }

      voltage = (float)result_volt/10.0;

      //      ""? U  >= 10.4 ?
      if (voltage >= (float)10.4)
      {
         Wait(MORSE_DOT_LENGTH*11);                          // 

         //   ""
         PTT_ON();

         //  20, 10, 5  3      
         if (voltage >= (float)16.5)       // >= 16.5 ?
         {
            Wait(20 * BASE_TIME_OFF); // 20 
         }
         else if (voltage >= (float)15.5)  // >= 15.5 ?
         {
            Wait(10 * BASE_TIME_OFF); // 10 
         }
         else if (voltage >= (float)14.5)  // >= 14.5 ?
         {
            Wait(5 * BASE_TIME_OFF);  // 5 
         }
         else
         {
            Wait(3 * BASE_TIME_OFF);  // 3  -   14.5 > U >= 10.4
         }
         //  
         PTT_OFF();
      }

      Wait(MORSE_DOT_LENGTH); //   

      Power_OFF();

      Wait((UINT32)((float)BASE_TIME_OFF*(float)beaconTimeOff[(UINT16)(((float)result_volt+5.0)/10.0)]));
   }
   return 0;
}

/***************************************
 *                  *
 *    2  -       *
 *    2.5                 *
 ***************************************/
void Wait_us(UINT16 pause)
{
   do
   {
      __asm__ volatile("nop");
   }
   while(--pause);
}

/***************************************
 *                  *
 *    2  -    *
 ***************************************/
void Wait_ms(UINT16 pause)
{
   do
   {
      Wait_us(400);
   }
   while (--pause);
}

/*************************************************************************
 * +----+----+----+-------------------------------------------------+
 * CS12CS11CS10                                         
 * +----+----+----+-------------------------------------------------+
 * 0   0   0   / 1                       
 * +----+----+----+-------------------------------------------------+
 * 0   0   1   CK                                               
 * +----+----+----+-------------------------------------------------+
 * 0   1   0   CK/8                                             
 * +----+----+----+-------------------------------------------------+
 * 0   1   1   CK/64                                            
 * +----+----+----+-------------------------------------------------+
 * 1   0   0   CK/256                                           
 * +----+----+----+-------------------------------------------------+
 * 1   0   1   CK/1024                                          
 * +----+----+----+-------------------------------------------------+
 *************************************************************************/
void StartTCNT1(void)
{
   TCNT1  = DOT_LENTH_IN_TIMER_TICKS;
   TIFR   |= _BV(TOV1); //    - 1,   
   TCCR1B |= _BV(CS11); //  = 8 + 
}

/*************************************************
 *   / 1                      *
 *************************************************/
void StopTCNT1(void)
{
   TIFR |= _BV(TOV1);            //    - 1,   
   TCCR1B &= ~(_BV(CS10)|_BV(CS11)|_BV(CS12));  //  = 0 , .. 
}

/*************************************************
 *    LC72131         *
 *************************************************/
void ProgramSynth(void)
{
   UINT32        ctrl_word; // 32-    / LC72131

   //   IN1
   ctrl_word   =  devider;               // 
   ctrl_word  ^=  freq_step_code;        //   
   ctrl_word  ^=  IN1;                   //    1
   send_word(ctrl_word);

   //   IN2
   ctrl_word  =   CTRL_WORD2;
   ctrl_word ^=   IN2;                   //    1
   send_word(ctrl_word);
}
